Unit AL;

Interface

Type
  ALbyte    = ShortInt; // 1-byte signed
  ALshort   = Integer;  // 2-byte signed
  ALint     = LongInt;  // 4-byte signed

  ALfloat   = Single;
  ALdouble  = Double;
  ALboolean = Boolean;

  ALubyte   = Byte;     // 1-byte unsigned
  ALushort  = Word;     // 2-byte unsigned
  ALuint    = DWord;    // 4-byte signed

  ALsizei   = LongInt;  // 4-byte signed

  ALenum    = DWord;

  PALBoolean = ^ALBoolean;
  PALFloat   = ^ALfloat;
  PALDouble  = ^ALDouble;
  PALbyte    = ^ALbyte;
  PALshort   = ^ALshort;
  PALint     = ^ALint;
  PALubyte   = ^ALubyte;
  PALushort  = ^ALushort;
  PALuint    = ^ALuint;

Const
  AL_INVALID                              = (-1);
  AL_NONE                                 = 0;
  AL_FALSE                                = 0;
  AL_TRUE                                 = 1;
  AL_SOURCE_TYPE                          = $200;
  AL_SOURCE_ABSOLUTE                      = $201;
  AL_SOURCE_RELATIVE                      = $202;
  AL_CONE_INNER_ANGLE                     = $1001;
  AL_CONE_OUTER_ANGLE                     = $1002;
  AL_PITCH                                = $1003;
  AL_POSITION                             = $1004;
  AL_DIRECTION                            = $1005;
  AL_VELOCITY                             = $1006;
  AL_LOOPING                              = $1007;
  AL_BUFFER                               = $1009;
  AL_GAIN                                 = $100A;
  AL_MIN_GAIN                             = $100D;
  AL_MAX_GAIN                             = $100E;
  AL_ORIENTATION                          = $100F;
  AL_REFERENCE_DISTANCE                   = $1020;
  AL_ROLLOFF_FACTOR                       = $1021;
  AL_CONE_OUTER_GAIN                      = $1022;
  AL_MAX_DISTANCE                         = $1023;
  AL_CHANNEL_MASK                         = $3000;
  AL_SOURCE_STATE                         = $1010;
  AL_INITIAL                              = $1011;
  AL_PLAYING                              = $1012;
  AL_PAUSED                               = $1013;
  AL_STOPPED                              = $1014;
  AL_BUFFERS_QUEUED                       = $1015;
  AL_BUFFERS_PROCESSED                    = $1016;
  AL_FORMAT_MONO8                         = $1100;
  AL_FORMAT_MONO16                        = $1101;
  AL_FORMAT_STEREO8                       = $1102;
  AL_FORMAT_STEREO16                      = $1103;
  AL_FREQUENCY                            = $2001;
  AL_BITS                                 = $2002;
  AL_CHANNELS                             = $2003;
  AL_SIZE                                 = $2004;
  AL_DATA                                 = $2005;
  AL_UNUSED                               = $2010;
  AL_PENDING                              = $2011;
  AL_PROCESSED                            = $2012;

  AL_NO_ERROR                             = AL_FALSE;
  AL_INVALID_NAME                         = $A001;
  AL_INVALID_ENUM                         = $A002;
  AL_INVALID_VALUE                        = $A003;
  AL_INVALID_OPERATION                    = $A004;
  AL_OUT_OF_MEMORY                        = $A005;

  AL_VENDOR                               = $B001;
  AL_VERSION                              = $B002;
  AL_RENDERER                             = $B003;
  AL_EXTENSIONS                           = $B004;
  AL_DOPPLER_FACTOR                       = $C000;
  AL_DOPPLER_VELOCITY                     = $C001;
  AL_DISTANCE_MODEL                       = $D000;
  AL_INVERSE_DISTANCE                     = $D001;
  AL_INVERSE_DISTANCE_CLAMPED             = $D002;

Procedure alEnable(capability : ALenum); stdcall;
Procedure alDisable(capability : ALenum); stdcall;
Function alIsEnabled(capability : ALenum) : ALboolean; stdcall;
//Procedure alHint(target, mode : ALenum); stdcall;
Function alGetBoolean(param : ALenum) : ALboolean; stdcall;
Function alGetInteger(param : ALenum) : ALint; stdcall;
Function alGetFloat(param : ALenum) : ALfloat; stdcall;
Function alGetDouble(param : ALenum) : ALdouble; stdcall;
Procedure alGetBooleanv(param : ALenum; var data : ALboolean); stdcall;
Procedure alGetIntegerv(param : ALenum; var data : ALint); stdcall;
Procedure alGetFloatv(param : ALenum; var data : ALfloat); stdcall;
Procedure alGetDoublev(param : ALenum; var data : ALdouble); stdcall;
Function alGetString(param : ALenum) : PALubyte; stdcall;
Function alGetError : ALenum; stdcall;
Function alIsExtensionPresent(var fname : ALubyte) : ALboolean; stdcall;
Procedure alGetProcAddress(var fname : ALubyte); stdcall;
Function alGetEnumValue(var ename : ALubyte) : ALenum; stdcall;
Procedure alListeneri(param : ALenum; value : ALint); stdcall;
Procedure alListenerf(param : ALenum; value : ALfloat); stdcall;
Procedure alListener3f(param : ALenum; v1, v2, v3 : ALfloat); stdcall;
Procedure alListenerfv(param : ALenum; var values : ALfloat); stdcall;
Procedure alGetListeneri(param : ALenum; var value : ALint); stdcall;
Procedure alGetListenerf(param : ALenum; var value : ALfloat); stdcall;
Procedure alGetListener3f(param : ALenum; var v1 : ALfloat; var v2 : ALfloat; var v3 : ALfloat); stdcall;
Procedure alGetListenerfv(param : ALenum; var values : ALfloat); stdcall;
Procedure alGenSources(n : ALsizei; var sources : ALuint); stdcall;
Procedure alDeleteSources(n : ALsizei; var sources : ALuint); stdcall;
Function alIsSource(id : ALuint) : ALboolean; stdcall;
Procedure alSourcei(source : ALuint; param : ALenum; value : ALint); stdcall;
Procedure alSourcef(source : ALuint; param : ALenum; value : ALfloat); stdcall;
Procedure alSource3f(source : ALuint; param : ALenum; v1, v2, v3 : ALfloat); stdcall;
Procedure alSourcefv(source : ALuint; param : ALenum; var values : ALfloat); stdcall;
Procedure alGetSourcei(source : ALuint; param : ALenum; var value : ALint); stdcall;
Procedure alGetSourcef(source : ALuint; param : ALenum; var value : ALfloat); stdcall;
//Procedure alGetSource3f(source : ALuint; param : ALenum; var v1 : ALfloat; var v2 : ALfloat; var v3 : ALfloat); stdcall;
Procedure alGetSourcefv(source : ALuint; param : ALenum; var values : ALfloat); stdcall;
Procedure alSourcePlayv(n : ALsizei; var sources : ALuint); stdcall;
Procedure alSourcePausev(n : ALsizei; var sources : ALuint); stdcall;
Procedure alSourceStopv(n : ALsizei; var sources : ALuint); stdcall;
Procedure alSourceRewindv(n : ALsizei; var sources : ALuint); stdcall;
Procedure alSourcePlay(source : ALuint); stdcall;
Procedure alSourcePause(source : ALuint); stdcall;
Procedure alSourceStop(source : ALuint); stdcall;
Procedure alSourceRewind(source : ALuint); stdcall;
Procedure alGenBuffers(n : ALsizei; var buffers : ALuint); stdcall;
Procedure alDeleteBuffers(n : ALsizei; var buffers : ALuint); stdcall;
Function alIsBuffer(buffer : ALuint) : ALboolean; stdcall;
Procedure alBufferData(buffer : ALuint; format : ALenum; var data; size, freq : ALsizei); stdcall;
Procedure alGetBufferi(buffer : ALuint; param : ALenum; var value : ALint); stdcall;
Procedure alGetBufferf(buffer : ALuint; param : ALenum; var value : ALfloat); stdcall;
Procedure alSourceQueueBuffers(source : ALuint; n : ALsizei; var buffers : ALuint); stdcall;
Procedure alSourceUnqueueBuffers(source : ALuint; n : ALsizei; var buffers : ALuint); stdcall;
Procedure alDistanceModel(value : ALenum); stdcall;
Procedure alDopplerFactor(value : ALfloat); stdcall;
Procedure alDopplerVelocity(value : ALfloat); stdcall;

Type
  ALCbyte    = ShortInt; // 1-byte signed
  ALCshort   = Integer;  // 2-byte signed
  ALCint     = LongInt;  // 4-byte signed

  ALCfloat   = Single;
  ALCdouble  = Double;
  ALCboolean = Boolean;

  ALCubyte   = Byte;     // 1-byte unsigned
  ALCushort  = Word;     // 2-byte unsigned
  ALCuint    = DWord;    // 4-byte signed

  ALCsizei   = LongInt;  // 4-byte signed

  ALCenum    = DWord;

  ALCContext = Pointer;
  ALCDevice  = Pointer;

  PALCBoolean = ^ALCBoolean;
  PALCFloat   = ^ALCfloat;
  PALCDouble  = ^ALCDouble;
  PALCbyte    = ^ALCbyte;
  PALCshort   = ^ALCshort;
  PALCint     = ^ALCint;
  PALCubyte   = ^ALCubyte;
  PALCushort  = ^ALCushort;
  PALCuint    = ^ALCuint;

Const
  ALC_INVALID                             = (-1);
  ALC_FALSE                               = 0;
  ALC_TRUE                                = 1;
  ALC_NO_ERROR                            = ALC_FALSE;
  ALC_MAJOR_VERSION                       = $1000;
  ALC_MINOR_VERSION                       = $1001;
  ALC_ATTRIBUTES_SIZE                     = $1002;
  ALC_ALL_ATTRIBUTES                      = $1003;
  ALC_DEFAULT_DEVICE_SPECIFIER            = $1004;
  ALC_DEVICE_SPECIFIER                    = $1005;
  ALC_EXTENSIONS                          = $1006;
  ALC_FREQUENCY                           = $1007;
  ALC_REFRESH                             = $1008;
  ALC_SYNC                                = $1009;
  ALC_INVALID_DEVICE                      = $A001;
  ALC_INVALID_CONTEXT                     = $A002;
  ALC_INVALID_ENUM                        = $A003;
  ALC_INVALID_VALUE                       = $A004;
  ALC_OUT_OF_MEMORY                       = $A005;

//Function alcGetString(var device : ALCdevice; param : ALCenum) : PALCubyte; stdcall;
//Procedure alcGetIntegerv(var device : ALCdevice; param : ALCenum; size : ALCsizei; var data : ALCint); stdcall;
Function alcOpenDevice(deviceName : PChar) : ALCdevice; stdcall;
Procedure alcCloseDevice(device : ALCdevice); stdcall;
Function alcCreateContext(device : ALCdevice; attrList : PALCint) : ALCcontext; stdcall;
Function alcMakeContextCurrent(context : ALCcontext) : ALCboolean; stdcall;
Procedure alcProcessContext(var context : ALCcontext); stdcall;
Function alcGetCurrentContext : ALCcontext; stdcall;
Function alcGetContextsDevice(var context : ALCcontext) : ALCdevice; stdcall;
Procedure alcSuspendContext(context : ALCcontext); stdcall;
Procedure alcDestroyContext(context : ALCcontext); stdcall;
Function alcGetError(device : ALCdevice) : ALCenum; stdcall;
//Function alcIsExtensionPresent(var device : ALCdevice; var extName : ALCubyte) : ALCboolean; stdcall;
//Procedure alcGetProcAddress(var device : ALCdevice; var funcName : ALCubyte); stdcall;
//Function alcGetEnumValue(var device : ALCdevice; var enumName : ALCubyte) : ALCenum; stdcall;

Implementation

Procedure alEnable(capability : ALenum); stdcall; external 'openal';
Procedure alDisable(capability : ALenum); stdcall; external 'openal';
Function alIsEnabled(capability : ALenum) : ALboolean; stdcall; external 'openal';
//Procedure alHint(target, mode : ALenum); stdcall; external 'openal';
Function alGetBoolean(param : ALenum) : ALboolean; stdcall; external 'openal';
Function alGetInteger(param : ALenum) : ALint; stdcall; external 'openal';
Function alGetFloat(param : ALenum) : ALfloat; stdcall; external 'openal';
Function alGetDouble(param : ALenum) : ALdouble; stdcall; external 'openal';
Procedure alGetBooleanv(param : ALenum; var data : ALboolean); stdcall; external 'openal';
Procedure alGetIntegerv(param : ALenum; var data : ALint); stdcall; external 'openal';
Procedure alGetFloatv(param : ALenum; var data : ALfloat); stdcall; external 'openal';
Procedure alGetDoublev(param : ALenum; var data : ALdouble); stdcall; external 'openal';
Function alGetString(param : ALenum) : PALubyte; stdcall; external 'openal';
Function alGetError : ALenum; stdcall; external 'openal';
Function alIsExtensionPresent(var fname : ALubyte) : ALboolean; stdcall; external 'openal';
Procedure alGetProcAddress(var fname : ALubyte); stdcall; external 'openal';
Function alGetEnumValue(var ename : ALubyte) : ALenum; stdcall; external 'openal';
Procedure alListeneri(param : ALenum; value : ALint); stdcall; external 'openal';
Procedure alListenerf(param : ALenum; value : ALfloat); stdcall; external 'openal';
Procedure alListener3f(param : ALenum; v1, v2, v3 : ALfloat); stdcall; external 'openal';
Procedure alListenerfv(param : ALenum; var values : ALfloat); stdcall; external 'openal';
Procedure alGetListeneri(param : ALenum; var value : ALint); stdcall; external 'openal';
Procedure alGetListenerf(param : ALenum; var value : ALfloat); stdcall; external 'openal';
Procedure alGetListener3f(param : ALenum; var v1 : ALfloat; var v2 : ALfloat; var v3 : ALfloat); stdcall; external 'openal';
Procedure alGetListenerfv(param : ALenum; var values : ALfloat); stdcall; external 'openal';
Procedure alGenSources(n : ALsizei; var sources : ALuint); stdcall; external 'openal';
Procedure alDeleteSources(n : ALsizei; var sources : ALuint); stdcall; external 'openal';
Function alIsSource(id : ALuint) : ALboolean; stdcall; external 'openal';
Procedure alSourcei(source : ALuint; param : ALenum; value : ALint); stdcall; external 'openal';
Procedure alSourcef(source : ALuint; param : ALenum; value : ALfloat); stdcall; external 'openal';
Procedure alSource3f(source : ALuint; param : ALenum; v1, v2, v3 : ALfloat); stdcall; external 'openal';
Procedure alSourcefv(source : ALuint; param : ALenum; var values : ALfloat); stdcall; external 'openal';
Procedure alGetSourcei(source : ALuint; param : ALenum; var value : ALint); stdcall; external 'openal';
Procedure alGetSourcef(source : ALuint; param : ALenum; var value : ALfloat); stdcall; external 'openal';
//Procedure alGetSource3f(source : ALuint; param : ALenum; var v1 : ALfloat; var v2 : ALfloat; var v3 : ALfloat); stdcall; external 'openal';
Procedure alGetSourcefv(source : ALuint; param : ALenum; var values : ALfloat); stdcall; external 'openal';
Procedure alSourcePlayv(n : ALsizei; var sources : ALuint); stdcall; external 'openal';
Procedure alSourcePausev(n : ALsizei; var sources : ALuint); stdcall; external 'openal';
Procedure alSourceStopv(n : ALsizei; var sources : ALuint); stdcall; external 'openal';
Procedure alSourceRewindv(n : ALsizei; var sources : ALuint); stdcall; external 'openal';
Procedure alSourcePlay(source : ALuint); stdcall; external 'openal';
Procedure alSourcePause(source : ALuint); stdcall; external 'openal';
Procedure alSourceStop(source : ALuint); stdcall; external 'openal';
Procedure alSourceRewind(source : ALuint); stdcall; external 'openal';
Procedure alGenBuffers(n : ALsizei; var buffers : ALuint); stdcall; external 'openal';
Procedure alDeleteBuffers(n : ALsizei; var buffers : ALuint); stdcall; external 'openal';
Function alIsBuffer(buffer : ALuint) : ALboolean; stdcall; external 'openal';
Procedure alBufferData(buffer : ALuint; format : ALenum; var data; size, freq : ALsizei); stdcall; external 'openal';
Procedure alGetBufferi(buffer : ALuint; param : ALenum; var value : ALint); stdcall; external 'openal';
Procedure alGetBufferf(buffer : ALuint; param : ALenum; var value : ALfloat); stdcall; external 'openal';
Procedure alSourceQueueBuffers(source : ALuint; n : ALsizei; var buffers : ALuint); stdcall; external 'openal';
Procedure alSourceUnqueueBuffers(source : ALuint; n : ALsizei; var buffers : ALuint); stdcall; external 'openal';
Procedure alDistanceModel(value : ALenum); stdcall; external 'openal';
Procedure alDopplerFactor(value : ALfloat); stdcall; external 'openal';
Procedure alDopplerVelocity(value : ALfloat); stdcall; external 'openal';

//Function alcGetString(var device : ALCdevice; param : ALCenum) : PALCubyte; stdcall; external 'openal';
//Procedure alcGetIntegerv(var device : ALCdevice; param : ALCenum; size : ALCsizei; var data : ALCint); stdcall; external 'openal';
Function alcOpenDevice(deviceName : PChar) : ALCdevice; stdcall; external 'openal';
Procedure alcCloseDevice(device : ALCdevice); stdcall; external 'openal';
Function alcCreateContext(device : ALCdevice; attrList : PALCint) : ALCcontext; stdcall; external 'openal';
Function alcMakeContextCurrent(context : ALCcontext) : ALCboolean; stdcall; external 'openal';
Procedure alcProcessContext(var context : ALCcontext); stdcall; external 'openal';
Function alcGetCurrentContext : ALCcontext; stdcall; external 'openal';
Function alcGetContextsDevice(var context : ALCcontext) : ALCdevice; stdcall; external 'openal';
Procedure alcSuspendContext(context : ALCcontext); stdcall; external 'openal';
Procedure alcDestroyContext(context : ALCcontext); stdcall; external 'openal';
Function alcGetError(device : ALCdevice) : ALCenum; stdcall; external 'openal';
//Function alcIsExtensionPresent(var device : ALCdevice; var extName : ALCubyte) : ALCboolean; stdcall; external 'openal';
//Procedure alcGetProcAddress(var device : ALCdevice; var funcName : ALCubyte); stdcall; external 'openal';
//Function alcGetEnumValue(var device : ALCdevice; var enumName : ALCubyte) : ALCenum; stdcall; external 'openal';

End.
